# This file is part of SSHare.
#
# SSHare is free software: you can redistribute it and/or modify it under the terms of
# the GNU General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later version.
#
# SSHare is distributed in the hope that it will be useful, but WITHOUT ANY
# WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
# more details.
#
# You should have received a copy of the GNU General Public License along with
# SSHare. If not, see <https://www.gnu.org/licenses/>.

import pyclip

from sshare.plugin.config import Argument
from sshare.plugin.config import Flag
from sshare.plugin.config import NoDefault
from sshare.plugin.source import Raw

plugin_type = { "source", "feedback" }

activate = {
    "source": { "type" },
    "feedback": { "to_clipboard" },
}
args = {
    "type": Argument(
        name="paste",
        nargs="?",
        const=Flag,
        default="txt",
        help="Upload the contents of the clipboard as text"
    ),
    "to_clipboard": Flag(
        name="copy",
        help="Copy the resultant URL to the clipboard"
    ),
}

def get_source():
    logger.info("Uploading contents of clipboard")
    return Raw(config.type, pyclip.paste())

def give_feedback(location):
    pyclip.copy(location)
